<?php 
/*
Plugin Name: Radiohost Widgets
Plugin URI: http://widget.radiohost.pl
Description: Wtyczka umożliwiająca implementacje widgetów radiowych radiohost.pl
Version: 0.51
Author: Sławomir Kaleta, Radosław Piórkowski, Jakub Kubik
GNU General Public License, Free Software Foundation <http://creativecommons.org/licenses/GPL/2.0/>
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

class radiohostWidgets

{

	public $inUse = null;
	public $addToFooter = null;

	public function __construct(){
		add_action( 'init', array( $this, 'init' ) );
	}

	function init(){

		add_action('admin_menu', array($this, 'radioHostWidgetsMenu')); // Menu page
		add_action('wp_head', array($this, 'mainJs')); //Loading js in head

        add_shortcode('RadioHost', array($this, 'bartagFunc'));
        add_filter('widget_text', 'do_shortcode'); 
        add_filter('widget_title', 'do_shortcode');

	}

    function curl_get_contents($url, $data = false){
        $ch = curl_init();
    
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    
        $data = curl_exec($ch);
        curl_close($ch);
    
        return $data;
    }

    public function mainJs(){

        if(!wp_script_is('jquery')){
            echo '<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script>';
        }

        echo '<script src="https://widget.radiohost.pl/api/v2/script.js"></script>';
        echo '<script src="http://widget.radiohost.pl/script.js?v=1.0"></script>';

    }

    public function radioHostWidgetsMenu() {

        add_menu_page('Widgety RadioHost', 'RadioHost', 'administrator', __FILE__, array($this, 'settingsPage') , plugins_url('/img/icon.png', __FILE__) ); //create new top-level menu
        //add_action( 'admin_init', 'register_my_cool_plugin_settings'); //call register settings function

    }

    public function settingsPage(){
       	require_once('settingsPage.php');
       	settingsPage();
    }

    // [bartag foo="foo-value"]

    public function bartagFunc($atts) {

        $a = shortcode_atts(array(
            'server_id' => '5', // default serverId
            'hash' => '9e192', // default hash for serverId
            'type' => 'information' // exampleWidget

        ), $atts);

    
        foreach ($atts as $key => $value) {
        	if(!isset($a[$key]))
        		$a[$key] = $value;
        }

        $code = '<!-- RH widgets -->';
        wp_enqueue_style('widget'.$a['type'], plugin_dir_url( __FILE__ ).'widgets/'.$a['type'].'/style.css', false, '1.0','all');

        echo '<script> var $ = jQuery; </script>';
        $code .= $this->curl_get_contents(plugins_url('widgets/'.$a['type'].'/'.$a['type'].'.php', __FILE__), http_build_query($a)); 
        return $code;

    }

}
$var = new radiohostWidgets();